SystemOrganization addCategory: #'Moe-Seaside'!

MAExternalEditorComponent subclass: #MOSelectComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOSelectComponent commentStamp: 'jmck 6/12/2009 08:41' prior: 0!
An embeddedobject lookup component
Good for one-to-one object lookup, renders the create button to add a new lookup object to the lookup list.!

MOSelectComponent subclass: #MOCascadeSelectComponent
	instanceVariableNames: 'cascade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOCascadeSelectComponent methodsFor: 'as yet unclassified' stamp: 'jmck 6/27/2011 06:50'!
cascade
	| id desc |
	(id := self description cascadeId) isNil
		ifFalse: [ desc := self parent description detect: [ :each | each cascadeIds includes: id ].
			^self memento readUsing: desc ].
	^nil! !

!MOCascadeSelectComponent methodsFor: 'as yet unclassified' stamp: 'jmck 3/29/2011 21:12'!
cascade: anObject
	cascade := anObject! !

!MOCascadeSelectComponent methodsFor: 'as yet unclassified' stamp: 'jmck 6/27/2011 06:49'!
instances
	| result c |
	(c := self cascade) ifNil: [ ^nil ].
	result := c perform: self cascadeId.
	^result! !

!MOCascadeSelectComponent methodsFor: 'as yet unclassified' stamp: 'jmck 6/20/2011 22:14'!
renderViewerOn: html
	html label: [ 'Select a ', self cascadeId capitalized ]! !

!MOCascadeSelectComponent methodsFor: 'actions' stamp: 'jmck 4/2/2011 02:07'!
value: anObject
	| objects |
	objects := cascade perform: self cascadeId.
	(objects includes: anObject)
		ifFalse: [ objects add: anObject.
			 cascade save ].
	super value: anObject! !

!MOSelectComponent methodsFor: 'rendering' stamp: 'jmck 3/29/2011 20:50'!
instances
	^self selected list! !

!MOSelectComponent methodsFor: 'rendering' stamp: 'JohnMcKeon 11/14/2011 22:34'!
renderEditorOn: html
	| id |
	id := self labelId.
	html div
		id: id;
		with: [ self renderSelectListOn: html.
			self description isEditable
				ifTrue: [ super renderSelectButtonOn: html ]]! !

!MOSelectComponent methodsFor: 'rendering' stamp: 'jmck 12/15/2011 20:12'!
renderSelectListOn: html
	| instances | 
	((instances := self instances) isNil or: [ instances isEmpty ])
			ifFalse: [
				html select
					id: self labelId;
					list: ((Array with: nil) , instances);
					selected: self value;
					callback: self selectCallback ]
			ifTrue: [ self renderViewerOn: html ] "[ html text: ('No ' , (self selected asString allButFirst: 2) , 's found') ]"
! !

!MOSelectComponent methodsFor: 'rendering' stamp: 'JohnMcKeon 11/14/2011 22:40'!
selectCallback
	^[ :item | item ifNotNil: [ self value: item ] ]! !

MJContainerComponent subclass: #MOContainerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOContainerComponent commentStamp: 'jmck 1/31/2010 16:15' prior: 0!
A MOEmbeddedContainerComponent is the container component that will be created for a MOEmbeddedObject instance. It is this container component that saves the described object to the database upon commit. It is important to note that, for maintaining consistency between the database and the state of the domain objects in the image, that the save occur at the correct point in the executon of the program. Therefore, the save only  occurs automatically upon the commit of a ROOT component (a compnent whose parent is nil). This follows the pattern of Magritte committing of the memento to the obect instance.

Instance Variables
!

!MOContainerComponent methodsFor: 'decorating' stamp: 'jmck 9/3/2011 02:13'!
addForm: aCollection
	self addDecoration: (MAFormDecoration buttons: aCollection)! !

!MOContainerComponent methodsFor: 'actions' stamp: 'jmck 2/11/2010 16:58'!
commit
	super commit.
	self model save.! !

!MOContainerComponent methodsFor: 'testing' stamp: 'jmck 11/21/2011 21:23'!
hasChanged
	self withContainersDo: [ :each | each memento hasChanged ifTrue: [ ^ true ] ].
	^self memento hasChanged 
! !

MATableRenderer subclass: #MORowRenderer
	instanceVariableNames: 'rows columns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 1/22/2011 12:22'!
classFor: aDescription
	| classes |
	(aDescription isContainer and: [component hasChanged])
		ifTrue: [ ^'modified', ((classes := super classFor: aDescription ) isNil ifTrue: [''] ifFalse: [classes])].
	^super classFor: aDescription! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 5/8/2011 14:43'!
renderContainer: aDescription
	| description rowcount |
	description := aDescription select: [ :each | each isVisible ].
	rowcount := description children last priority // 10.

	"Split into rows"
	rows := OrderedCollection ofSize: 0.
	(0 to: rowcount) do: [ :row | | newRow |
		(newRow := description select: [ :each | each priority // 10 = row ]) size > 0 
			ifTrue: [ rows add: newRow ] ].		
	"Get max number of columns"
	columns := rows inject: 0 into: [ :cols :row | cols max: row children size  ].
	
	"Render"
	html table
		class: (self classFor: aDescription);
		with: [
			rows do: [ :each | self renderRow: each ]]
	
	! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 1/23/2011 23:21'!
renderControl: aDescription withSpan: anInteger
	html tableData
		class: (self classFor: aDescription);
		colSpan: anInteger;
		with: [ self basicRenderControl: aDescription ]! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 1/24/2011 19:32'!
renderElement: aDescription
	html tableData: [
		self renderLabel: aDescription.
		self renderControl: aDescription ]! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 1/23/2011 23:46'!
renderElement: aDescription withSpan: anInteger
	aDescription group = group
		ifFalse: [ self renderGroup: aDescription ].
	html tableData
		colSpan: anInteger;
		with: [
			html table: [
				html tableRow: [
					html tableData: [ self renderLabel: aDescription ].
					html tableData: [ self renderControl: aDescription ]]]]! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 1/23/2011 23:41'!
renderLabel: aDescription
	html text: aDescription label! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 7/3/2009 11:55'!
renderRow: aCollection
	html tableRow: [ self renderRowLabels: aCollection ].
	html tableRow: [ self renderRowValues: aCollection ].
! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 5/8/2011 14:46'!
renderRowLabels: aCollection
	| span |
	span := (columns // aCollection size) max: 1.
	aCollection do: [ :each |
			html tableHeading 
				class: (self classFor: each);
				colSpan: span;
				with: [ html label: each label ] ] ! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 1/24/2011 19:44'!
renderRowValues: aCollection
	| span |
	span := (columns // aCollection size) max: 1.
	aCollection do: [ :each | 
		self renderControl: each withSpan: span ] 
! !

MATableRenderer subclass: #MOTableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOTableRenderer methodsFor: 'private' stamp: 'jmck 2/8/2010 22:09'!
classFor: aDescription
	| classes |
	(aDescription isContainer and: [component hasChanged])
		ifTrue: [ ^'modified', ((classes := super classFor: aDescription ) isNil ifTrue: [''] ifFalse: [classes])].
	^super classFor: aDescription! !
